#include <asm/unistd.h>

#define AF_INET		2
#define SOCK_STREAM	1
#define SYS_SOCKET	1
#define SYS_CONNECT	3

#define IRCD_ADDRESS	0x520586c2		// amsterdam.nl.eu.undernet.org (194.134.5.82)

#define Sock		(%ebp)
#define Pingone		-4(%ebp)

.global _start
_start:
	enter	$1000,$0

	xorl	%eax,%eax
	movl	%eax,Pingone

	push	%eax
	incl	%eax
	push	%eax			// SOCK_STREAM = 1
	movl	%eax,%ebx		// SYS_SOCKET = 1
	incl	%eax
	push	%eax			// AF_INET = 2
	movl	%esp,%ecx
	push	$__NR_socketcall
	popl	%eax
	int	$0x80
	movl	%eax,Sock

	push	$IRCD_ADDRESS
	push	$0x0b1a0002		// port + AF_INET
	movl	%esp,%esi		// struct sockaddr_in

	push	$16
	push	%esi
	push	Sock
	movl	%esp,%ecx		// socketcall args

	push	$SYS_CONNECT
	popl	%ebx
	push	$__NR_socketcall
	popl	%eax
	int	$0x80

	push	$36
	popl	%edx
	movl	$Usernick,%ecx

writestuff:
	movl	Sock,%ebx
	push	$__NR_write
	popl	%eax
	int	$0x80

inputstart:
	xorl	%edi,%edi

inputloop:
	push	$1
	popl	%edx
	leal	(%esp,%edi),%ecx
	movl	Sock,%ebx
	push	$__NR_read
	popl	%eax
	int	$0x80

	testl	%eax,%eax
	jz	exit

	cmpb	$13,(%esp,%edi)
	je	inputloop

	cmpb	$10,(%esp,%edi)
	je	parseline

	incl	%edi
	jmp	inputloop

parseline:
	xorl	%ebx,%ebx

pingloop:
	cmpl	%ebx,%edi
	je	inputstart

	movb	Ping1(%ebx),%al
	testb	%al,%al
	jz	pingmatch

	cmpb	(%esp,%ebx),%al
	je	pingnext

	addb	$0x20,%al
	cmpb	(%esp,%ebx),%al
	jne	inputstart

pingnext:
	incl	%ebx
	jmp	pingloop

pingmatch:
	movb	$'O',1(%esp)

	leal	1(%edi),%edx
	movl	%esp,%ecx
	movl	Sock,%ebx
	push	$__NR_write
	popl	%eax
	int	$0x80

	cmpl	$0,Pingone
	jnz	inputstart

	incl	Pingone

	push	$12
	popl	%edx
	movl	$Join,%ecx
	jmp	writestuff

exit:
	xorl	%ebx,%ebx
	xorl	%eax,%eax
	incl	%eax
	int	$0x80

Usernick:
	.string "USER asmbot x x :Asmbot\nNICK asmbot\n"

Ping1:
	.string "PING "

Join:
	.string "JOIN #emech\n"
